
set echo on

CREATE TYPE tkprof_ot AS OBJECT
( line NUMBER
, text VARCHAR2(4000)
);
/

CREATE TYPE tkprof_ntt AS TABLE OF tkprof_ot;
/

CREATE FUNCTION tkprof ( 
                p_tracefile IN VARCHAR2 DEFAULT NULL
                ) RETURN tkprof_ntt PIPELINED AS

   -----------------------------------------------------
   FUNCTION get_tracefile RETURN VARCHAR2 IS
      v_tracefile VARCHAR2(128);
   BEGIN
      SELECT REGEXP_SUBSTR(value, '[^/]+$')
      INTO   get_tracefile.v_tracefile
      FROM   v$diag_info
      WHERE  name = 'Default Trace File';
      RETURN get_tracefile.v_tracefile;
   END get_tracefile;

   -----------------------------------------------------
   PROCEDURE set_location( p_tracefile IN VARCHAR2 ) IS
      PRAGMA AUTONOMOUS_TRANSACTION;
   BEGIN
      EXECUTE IMMEDIATE 
         'ALTER TABLE tkprof_xt LOCATION (''' || 
             set_location.p_tracefile || ''')';
   END set_location;

BEGIN

   /* Set the external table location... */
   set_location(COALESCE(p_tracefile, get_tracefile));

   /* Pipe the data... */
   FOR r IN (SELECT * FROM tkprof_xt) LOOP
      PIPE ROW (tkprof_ot(r.line, r.text));
   END LOOP;

   RETURN;

EXCEPTION
   WHEN NO_DATA_NEEDED THEN
      NULL;
END tkprof;
/

SELECT *
FROM   TABLE(tkprof);

SELECT *
FROM   TABLE(tkprof('&tracefile'));

undefine tracefile

